#include "cons_map.hh"

void UsedMap::Analyze()
{
#if 0
	for(unsigned y=0; y<ys-1; ++y)
		for(unsigned x=0; x<xs-1; ++x)
		{
			int n = at(calcofs(x,y));
			printf("\33[%u;%uH%c", y+1,x+1, ".uB"[(int)n]);
		}
	fflush(stdout);
#endif
	for(unsigned ofs=size(), y=ys; y>0; )
	{
		--y;
		for(unsigned count=0, x=xs; x>0; )
		{
			--x;
			--ofs;
			at(ofs).x =
				(at(ofs) != am_free)
					? count = 0
					: ++count;
		}
	}
	for(unsigned ofs=size(), x=xs; x>0; )
	{
		--x;
		--ofs;
		for(unsigned count=0, y=ys; y>0; )
		{
			--y;
			at(ofs).y =
				(at(ofs) != am_free)
					? count = 0
					: ++count;
			ofs -= xs;
		}
		ofs += size(); // ys*xs
	}
}

void UsedMap::SetBox(unsigned x1,unsigned y1, unsigned xsi,unsigned ysi, allocationmode value)
{
	unsigned ofs = calcofs(x1,y1);
	// printf("ofs=%u (%u,%u), xsi=%u,ysi=%u - setting to %u\n", ofs, x1,y1, xsi,ysi, value);
	// fflush(stdout);
	for(unsigned yp=0; yp<ysi; ++yp)
	{
		for(unsigned xp=0; xp<xsi; ++xp)
			at(ofs++) = value;
		ofs += xsize()-xsi;
	}
	// printf("Done that\n"); fflush(stdout);
	unsigned y;
	for(ofs=y=0; y<ys; ++y)
	{
	//  printf("Testing %u at line %u\n", am_bad, y);
 	for(unsigned x=0; x<xsize(); ++x)
			if(at(ofs++) != am_bad)goto Done;
	}
Done:
	if(y)
	{
	// printf("Found %u bad\n", y);
		// Number of useless rows at top, unuse them.
		ofs = 0;
		unsigned ofs2 = y * xsize();
		unsigned nmax = xsize() * (ys-y);
		for(unsigned n=0; n<nmax; ++n)
			at(ofs++) = at(ofs2++);
		top += y;
	}
}

// Returns false, if EmptyBox(x1,y1, xmin,ymin) would return false
bool UsedMap::BiggestEmptyAt(unsigned x1,unsigned y1, Screen::xycoord &dest,
                             unsigned xmin, unsigned ymin, favors favor)
{
	if(!EmptyBox(x1,y1, xmin,ymin))return false;
	
	unsigned bgest = 0;
	
	unsigned ofs1 = calcofs(x1, y1);
	
	// EmptySquareX:
	
	for(unsigned ofs=ofs1, minsize=at(ofs).y, x=1; x<xs-x1; ++x)
	{
		++ofs;
		unsigned siz = at(ofs).y;
		if(siz < minsize)minsize = siz;
		
		// fprintf(stderr, "EmptySquareX: (%u,%u): x=%u,siz=%u, size=%u\n", x1,y1, x,siz,size);
		
		unsigned score = 
			(favor==favor_x) ? x :
			(favor==favor_y) ? minsize :
			x * minsize;
		
		if(score > bgest)
		{
			bgest = score;
			dest.x = x;
			dest.y = minsize;
		}
	}

	// EmptySquareY:
	
	for(unsigned ofs=ofs1, minsize=at(ofs).x, y=1; y<ys+top-y1; ++y)
	{
		ofs += xs;
		unsigned siz = at(ofs).x;
		if(siz < minsize)minsize = siz;
		
		// fprintf(stderr, "EmptySquareY: (%u,%u): siz=%u,y=%u, size=%u\n", x1,y1, siz,y,size);
		
		unsigned score = 
			(favor==favor_x) ? minsize :
			(favor==favor_y) ? y :
			minsize * y;
		
		if(score > bgest)
		{
			bgest = score;
			dest.x = minsize;
			dest.y = y;
		}
	}

	return true;
}
