#ifndef bsq_inputevent_hh
#define bsq_inputevent_hh

#include "autoptr.hh"

enum inputtype { inputnone, inputkey, inputchar,
                 inputalt, inputctrl };

enum inputkeytype
   { KbLt, KbRt, KbUp, KbDn, KbBackSpace,
     KbDelete, KbInsert, KbPgUp, KbPgDn,
     KbHome, KbEnd, KbTab, KbShiftTab,
     KbEnter, KbEsc };

typedef autoptr<class InputEvent> evptr;
class InputEvent : public ptrable
{
public:
	inputtype type;
	
	union
	{
		inputkeytype key;
		BYTE character;
	};
	evptr ev;
public:
	InputEvent() { }
	InputEvent(BYTE ch) : type(inputchar), character(ch) { }
	InputEvent(inputkeytype k) : type(inputkey), key(k) { }
	InputEvent(evptr e) : type(inputalt), ev(e) { }
};

#endif
