#include "loadmeter.hh"

LoadMeter::LoadMeter(const char *fmt...) : region(Display.AllocateLine())
{
	va_list ap;
	va_start(ap, fmt);
	unsigned len = region.printf(fmt, ap);
	va_end(ap);
	
	max = region.xsize() - 4 - len;
	
	region.printf(" [");
	region.putchar('.', max);
	region.printf("]");
	region.putchar('\b', max+1);
	region.flush();
	
	pos = 0;
}

void LoadMeter::tick(long n, long whole)
{
	unsigned newpos = n * max / whole;
	
	if(pos < newpos)
		region.putchar(':',  newpos-pos);
	else
		region.puts("\b.\b", pos-newpos);
	region.flush();
	
	pos = newpos;
}
